# Official imapsync migration tool ( release <!--#exec cmd="cat ./VERSION"--> )
Imapsync is an IMAP sync tool. It syncs all folders from one mailbox to another, both anywhere on the Internet or in your local network.
Author: Gilles LAMIRAL
Keywords: imap, transfer, migration, backup

# Welcome to the imapsync web site!

## Is it time to copy all your emails and folders elsewhere?

Site last updated on

## What is imapsync? (back to menu)

Imapsync is an IMAP transfers tool. The purpose of imapsync is to migrate IMAP accounts or to backup IMAP accounts. IMAP is one of the three current standard protocols to access mailboxes, the two other are POP3 and HTTP with webmails, webmails are often tied to an IMAP server.

Latest imapsync published release was written on

Imapsync software is a command line tool that allows incremental and recursive IMAP transfers from one mailbox to another, both anywhere on the internet or in your local network. Imapsync runs on Windows, Linux, Mac OS X. "Incremental" means you can stop the transfer at any time and restart it later efficiently, without generating duplicates. "Recursive" means the complete folders hierarchy can be copied, all folders, all subfolders etc. "Command line" means it's not a graphical tool, on Windows you have to run imapsync from a batch file. Anyway there is a visual online service, you can try imapsync at https://i005.lamiral.info/X/

Imapsync can't migrate Contacts and Calendars. Most email systems don't set or get Contacts or Calendars via the IMAP protocol. No way via IMAP, no way via imapsync but it can be done with other tools or via export/import of csv or ics files. Also consider using caldavsynchronizer or asking experts at Sumatra company.

imapsync is not suitable for maintaining a synchronization between two active imap accounts while the user is working on both sides. Use offlineimap (written by John Goerzen) or mbsync (written by Michael R. Elkins) for bidirectionnal (2 ways) synchronizations.

Alternatives to imapsync are listed in the Similar softwares section.

## Contact the author, Gilles LAMIRAL (back to menu)

Gilles LAMIRAL
gilles@lamiral.info
work cel: +33 6 19 22 03 54
work desk: +33 9 51 84 42 42
Postal address:
22 La Billais
BAULON 35580
FRANCE

Good feedback is always welcome!
and bad feedback is very often welcome

## Buy imapsync and support (back to menu)

Buy complete and latest imapsync for €60 EUR.
There is no trial version but I offer 30-day money back guarantee whatever the reason for a refund. Or drop me a gentle email and I will provide you the latest imapsync because, well, you made the effort to contact me.
After buying and downloading imapsync, go to the installation documentation.

For €60 EUR you will get:

- Standalone imapsync.exe for win32, easy installation done by a zip extraction anywhere. See README_Windows.txt for details.
- Standalone imapsync_bin_Darwin for Mac OS X.
- Imapsync Perl source code for any operating system, Unix, Windows, OS X.
- The online visual interface, like /X, to install the service on a Linux server (not working on Windows yet).
- Lifetime of imapsync updates without extra payment.
- 30-day money back guarantee! No question nor condition to get a refund, really, just request it and you'll sure get a refund!
- No limit to do anything with imapsync and its license.

For €60 EUR independently, you get imapsync full professional support, provided by the imapsync designer and developer, Gilles LAMIRAL, your servitor, who has been supporting imap migrations with imapsync for more than 18 years (I started in 2001). See a detailed support description below.

Special and recommended offer: it's only €100 EUR if you buy imapsync + support at once (instead of 60 + 60 = 120 EUR).

Imapsync buying options:
Professionals buyers outside France are VAT exempted. Individuals or French buyers are VAT taxed.
In case you're a European professional, please enter your VAT number it is for accounting and customs declaration.
VAT is often 2 letters followed by 11 digits, for example mine is FR74429303332.
If you can't use Paypal then consider a Bank transfer.

At the end of the payment Paypal will proposed you to go back to the site, via a link to gilles@lamiral.info (it's my paypal account name), this link brings you to imapsync download.
You will also receive an email from gilles@lamiral.info a few minutes later (can fall in the Spam folder sometimes).
In order to get an accurate invoice, please make sure the delivery postal address you enter in Paypal suits your accounting department, since revised editing is not easy.
The gpg signed invoice will be sent within a few days by email, My company is identified by VAT number FR74429303332 or French SIRET number 42930333200051, French APE/NAF number 6201Z (programmation informatique).

### Support (back to menu)

For those of you who seek support, contact me, Gilles LAMIRAL, by email or phone:

- Email address: gilles@lamiral.info.
- Desk phone number: +33 9 51 84 42 42 located in France.
- Mobile phone number: +33 6 19 22 03 54 located in France (SFR operator).

The support is done in English, mostly by email or possibly phone/skype. Office hours start at 10:00, end at 16:00 UTC, extra time is possible in case of emergency. The support aims at helping you to get your imap migration job done, quickly if possible. Support includes things like no time to read the documentation, how to deal with special imap server softwares (Gmail, Exchange), choosing and explaining options, explaining error messages, solving authentication issues, dealing with speed, quotas, special context, running in parallel, etc., so in summary: anything!

I have been supporting imap migrations with imapsync since 2001, I still enjoy it!

### Payment by bank transfer and IBAN (back to menu)

If you can't pay with a credit card via Paypal then it is possible to pay via a bank transfer.

Refund for a bank transfer is far less easy than with Paypal so drop me an email to test imapsync and to be sure it will do what you need it to do, before any payment.
The bank account references will be given upon request.

## Facts and figures (back to menu)

- 6000 to 7000 users per month (45000 users a year).
- 7 to 12 millions mailboxes transfers per month.
- 108 millions transfers for 2018, that is more than three whole mailboxes synced per second in average, and an estimation of 38 Petabytes ( 1 PiB = 2^50 bytes = 1024^5 ~ 10^15) transferred in total, taking a mean of 400 Mbytes per mailbox (a mean given by online /X stats).
- Operating systems run by imapsync users (in 2018):
  - Linux: 69%
  - Win32: 16%
  - Darwin: 12%
  - FreeBSD: 1%
  - Solaris: 0.04%
  - OpenBSD: 0.04%
  - Unknown 0.01 %
  - Other: 0.83%
- Highest use rate: about 56 millions of IMAP mailbox transfers by just one host.
- Biggest known account migrated: 2.4 millions folders (figure independently reported).

Where all those numbers come from? To know whether a newer imapsync exists or not, imapsync does a http GET to the file VERSION. Via the User-agent parameter it also sends:

- imapsync release
- Perl version
- Mail::IMAPClient version
- Operating System

You can remove this behavior by adding option --noreleasecheck on the command line (or by setting $releasecheck = 0 in the source code). Check CVE-2013-4279.

## How to transfer a single mailbox on Windows (back to menu)

After Imapsync installation, a basic (and really working) example in a DOS window is the following:

    .\imapsync.exe  ^
      --host1 test1.lamiral.info  ^
      --user1 test1               ^
      --password1  "secret1"      ^
      --host2 test2.lamiral.info  ^
      --user2 test2               ^
      --password2  "secret2"

But it's better to edit a batch file and run it by a double-click. Take this batch file example imapsync_example.bat and adapt with your own parameters.

## How to transfer a single mailbox on Linux/Unix (back to menu)

After Imapsync installation, a basic (and really working) example in a shell terminal is the following:

    ./imapsync   \
      --host1 test1.lamiral.info  \
      --user1 test1               \
      --password1  "secret1"      \
      --host2 test2.lamiral.info  \
      --user2 test2               \
      --password2  "secret2"

But it's better to edit a shell script and run it in a terminal. Take this Bourne shell script example imapsync_example.sh and adapt with your own parameters.

## How to transfer many mailboxes (back to menu)

In order to migrate many mailboxes, you should use a loop over a csv file containing only the data credentials.
On Windows, see sync_loop_windows.bat batch example.
On Unix, see sync_loop_unix.sh example.
An example of this csv file is file.txt, it can be used with the two previous command scripts.
All example scripts can be found in the examples/* directory.

## Installation (back to menu)

Depending on the system where you'll run imapsync:

- Windows users, read directly README_Windows.txt.
- OS X users, read INSTALL.Darwin.txt.
- Centos users, read INSTALL.Centos.txt.
- CPanel users, read INSTALL.CPanel.txt.
- Debian users, read INSTALL.Debian.txt.
- AWS EC2 users, read INSTALL.AWS_EC2.txt.
- Ubuntu users, read INSTALL.Ubuntu.txt.
- ArchLinux users, read INSTALL.ArchLinux.txt.
- FreeBSD users, read INSTALL.FreeBSD.txt.
- Docker users, read INSTALL.Docker.txt or directly the Imapsync Docker page.
- Online UI sysadmins, wanting their own /X, read INSTALL.OnlineUI.txt
- Other users, read the second part of INSTALL.ANY.txt.
- All installation files are located in the INSTALL.d/ directory.

After the imapsync installation you should go to the documentation section just below.

## Documentation (back to menu)

Windows users, the README_Windows.txt contains essential knowledge to do your first syncs.

Unix users, the TUTORIAL_Unix will teach you smoothly how to do your first syncs. Windows users can read it too.

The README file contains general and specific pieces of information to understand imapsync and succeed in your migration or backup.

The FAQ.d/* files present Frequently Asked Questions (and not so frequently asked ones) and their answers. Here is the main menu:

Tips about imap server softwares:

- Gmail accounts. See Gmail limits.
- Exchange 20xx and Office365.
- Yahoo.
- Domino.
- Dovecot.
- Zimbra.
- SmarterMail.
- Other various imap software servers.
- Oracle-UCS.

Solving problems:

- Authentication failure.
- Changing folders names.
- Duplicated messages issues.
- Why use --addheader?
- Passwords on Windows.
- Passwords on Unix.
- Flags issues.
- Dates issues.
- Memory issue.
- Append errors.
- Contacts and Calendars issues.
- User concurrent access issues.
- Option --usecache and its issues.
- SSL errors.
- Is imapsync a virus?.

Various tips:

- Migration plan.
- Massive/bulk migrations.
- Selecting messages.
- Selecting folders.
- Sizes of folders.
- Admin authentication.
- Archiving tips.
- General FAQ.
- POP3 issues.
- Reporting bugs.
- Big mailboxes.
- ISP.
- TTL (MX change in DNS).
- Security.
- Emptying an account.
- XOAUTH2 (Gmail).

The ChangeLog to read what changed in details since 2001.

The TODO file lists what may be coded or done in the future.

All the people I thank are in the CREDITS file.

What you're allowed to do with imapsync is "No limits to do anything with this work and this license." like repeated in the LICENSE file (the detour is worth it).

This document last modified on ($Id: index.shtml,v 1.411 2019/01/11 17:25:51 gilles Exp gilles $)
Top of the page